;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "tempRS232.vec"
	.INCLUDE "tempRS232.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : TP3 liaison RS232
;      10 Version : 2
;      11 Date    : 24/01/2010
;      12 Author  : Philippe Mariano                         
;      13 Company : Lyce Pierre Emile Martin                             
;      14 Comments: Fichier lve
;      15 Transmission de la temprature ambiante sur la liaison srie
;      16 
;      17 Fichier: TempRS232.c
;      18 
;      19 Chip type           : ATmega8535
;      20 Program type        : Application
;      21 Clock frequency     : 8,000000 MHz
;      22 Memory model        : Small
;      23 External SRAM size  : 0
;      24 Data Stack size     : 128
;      25 *********************************************/
;      26 
;      27 #include <mega8535.h>
;      28 // -------------------------------------------------------------------------------------------------------
;      29 // Bibliothques  non gnres par Wizard ( rajouter manuellement)
;      30 // -------------------------------------------------------------------------------------------------------      
;      31 #include <delay.h>    // contient la fonction delay_ms
;      32 #include <stdio.h>    // contient la fonction sprintf 
;      33 #include <stdlib.h>   // contient la fonction itoa
;      34 #include <math.h>     // contient la fonction abs
;      35 #include <ssi.h>      // contient la fonction Affiche_LCD
;      36 // -------------------------------------------------------------------------------------------------------
;      37 // -------------------------------------------------------------------------------------------------------
;      38 // I2C Bus functions
;      39 #asm
;      40    .equ __i2c_port=0x12
   .equ __i2c_port=0x12
;      41    .equ __sda_bit=3
   .equ __sda_bit=3
;      42    .equ __scl_bit=7
   .equ __scl_bit=7
;      43 #endasm

;      44 #include <i2c.h>
;      45 // -------------------------------------------------------------------------------------------------------
;      46 // DS1621 Thermometer/Thermostat functions
;      47 #include <ds1621.h>
;      48 // -------------------------------------------------------------------------------------------------------
;      49 // Alphanumeric LCD Module functions
;      50 #asm
;      51    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      52 #endasm

;      53 #include <lcd.h>
;      54 // -------------------------------------------------------------------------------------------------------
;      55 
;      56 // -------------------------------------------------------------------------------------------------------
;      57 // Programme principal
;      58 // -------------------------------------------------------------------------------------------------------
;      59 void main(void)
;      60 {

	.CSEG
_main:
;      61 // Declare your local variables here   
;      62 // -------------------------------------------------------------------------------------------------------
;      63 //type 	   		nom 				   				dsignation  
;      64 // -------------------------------------------------------------------------------------------------------
;      65 char display_buffer_ligne0[17]; 					// tampon ligne 0 de l'afficheur
;      66 char display_buffer_ligne1[17]; 	       			// tampon ligne 1 de l'afficheur
;      67 unsigned int  temp_n_1, temp_n;						// Temprature  l'instant n et  l'instant n-1
;      68 unsigned int Aff_Temp_Entier, Aff_Temp_decimal ; 	// Partie entire et partie dcimale de la temprature  
;      69 // -------------------------------------------------------------------------------------------------------
;      70 // Input/Output Ports initialization
;      71 // Port A initialization
;      72 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In
;      73 // State0=P State1=T State2=T State3=T State4=T State5=T State6=T State7=T
;      74 PORTA=0x01;
	SBIW R28,36
;	display_buffer_ligne0 -> Y+19
;	display_buffer_ligne1 -> Y+2
;	temp_n_1 -> R16,R17
;	temp_n -> R18,R19
;	Aff_Temp_Entier -> R20,R21
;	Aff_Temp_decimal -> Y+0
	LDI  R30,LOW(1)
	OUT  0x1B,R30
;      75 DDRA=0x00;
	CLR  R30
	OUT  0x1A,R30
;      76 // -------------------------------------------------------------------------------------------------------
;      77 // USART initialization
;      78 // Communication Parameters: 8 Data, 1 Stop, No Parity
;      79 // USART Receiver: Off
;      80 // USART Transmitter: On
;      81 // USART Mode: Asynchronous
;      82 // USART Baud rate: 9600
;      83 UCSRA=0x00;
	OUT  0xB,R30
;      84 UCSRB=0x08;
	LDI  R30,LOW(8)
	OUT  0xA,R30
;      85 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;      86 UBRRH=0x00;
	CLR  R30
	OUT  0x20,R30
;      87 UBRRL=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
;      88 // -------------------------------------------------------------------------------------------------------
;      89 // I2C Bus initialization
;      90 i2c_init();
	RCALL _i2c_init
;      91 // -------------------------------------------------------------------------------------------------------
;      92 // DS1621 Thermometer/Thermostat initialization
;      93 // tlow: 24C
;      94 // thigh: 55C
;      95 // Tout polarity: 0
;      96 ds1621_init(0,24,55,0);
	RCALL SUBOPT_0x0
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(55)
	ST   -Y,R30
	RCALL SUBOPT_0x0
	RCALL _ds1621_init
;      97 // -------------------------------------------------------------------------------------------------------
;      98 // LCD module initialization
;      99 lcd_init(16);   
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     100 
;     101 // -----------------------------------------------------------------------------------------------------------
;     102 // --------------------------------------------- Message d'accueil -------------------------------------------
;     103 // -----------------------------------------------------------------------------------------------------------
;     104 temp_n = ds1621_temperature_10(0);  
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
;     105 sprintf(display_buffer_ligne0,"Capteur DS1621  ");
	RCALL SUBOPT_0x2
	__POINTW1FN _101,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x3
;     106 sprintf(display_buffer_ligne1,"Temp. = %-i.%-u%-cC",temp_n/10,abs(temp_n%10),0xdf);
	__POINTW1FN _101,17
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x4
	RCALL __DIVW21U
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	LDI  R24,12
	RCALL SUBOPT_0x8
;     107 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x9
;     108 
;     109 while (1)
_0x66:
;     110       { 
;     111 // -----------------------------------------------------------------------------------------------------------
;     112 // --------------------------------------- Champs lecture des donnes ----------------------------------------
;     113 // -----------------------------------------------------------------------------------------------------------
;     114 // Lecture de la temprature mesure par le DS1621 toutes les secondes 
;     115 // -----------------------------------------------------------------------------------------------------------
;     116 	temp_n = ds1621_temperature_10(0);    
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
;     117 	
;     118 // -----------------------------------------------------------------------------------------------------------
;     119 // ------------------------------------------------ Champs Traitement ----------------------------------------
;     120 // -----------------------------------------------------------------------------------------------------------      
;     121 Aff_Temp_Entier =  temp_n/10;
	RCALL SUBOPT_0x4
	RCALL __DIVW21U
	__PUTW1R 20,21
;     122 Aff_Temp_decimal = abs(temp_n%10);    
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x6
	ST   Y,R30
	STD  Y+1,R31
;     123  
;     124 // -----------------------------------------------------------------------------------------------------------
;     125 // --------------------------------------- Champs criture des rsultats -------------------------------------
;     126 // -----------------------------------------------------------------------------------------------------------
;     127 // Affichage de la temprature sur le LCD et transfert vers le PC  
;     128 	if (!PINA.0)
	SBIC 0x19,0
	RJMP _0x69
;     129 	  { putchar('g'); delay_ms(100);}
	LDI  R30,LOW(103)
	RCALL SUBOPT_0xA
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     130 	else if (temp_n_1 != temp_n)
	RJMP _0x6A
_0x69:
	__CPWRR 18,19,16,17
	BREQ _0x6B
;     131  	  {  
;     132   		sprintf(display_buffer_ligne0,"Capteur DS1621  ");
	RCALL SUBOPT_0x2
	__POINTW1FN _101,37
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x3
;     133     	sprintf(display_buffer_ligne1,"Temp. = %-i.%-u%-cC",Aff_Temp_Entier, Aff_Temp_decimal,0xdf);
	__POINTW1FN _101,54
	ST   -Y,R31
	ST   -Y,R30
	__GETW1R 20,21
	RCALL SUBOPT_0x5
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	LDI  R24,12
	RCALL SUBOPT_0x8
;     134      	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x9
;     135         puts(display_buffer_ligne1);  
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _puts
;     136         putchar(0x0D);
	LDI  R30,LOW(13)
	RCALL SUBOPT_0xA
;     137         temp_n_1 = temp_n;	  
	__MOVEWRR 16,17,18,19
;     138       }    
;     139   };   // fin while(1)
_0x6B:
_0x6A:
	RJMP _0x66
;     140 } // fin main
	ADIW R28,36
_0x6C:
	RJMP _0x6C
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	put:
	RCALL SUBOPT_0xB
	SBIW R30,0
	BREQ _0xA3
	RCALL SUBOPT_0xB
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0xA4
_0xA3:
	LDD  R30,Y+2
	RCALL SUBOPT_0xA
_0xA4:
	ADIW R28,3
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0xA6:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0xA8
	MOV  R30,R16
	CPI  R30,0
	BRNE _0xAC
	CPI  R19,37
	BRNE _0xAD
	LDI  R16,LOW(1)
	RJMP _0xAE
_0xAD:
	RCALL SUBOPT_0xC
_0xAE:
	RJMP _0xAB
_0xAC:
	CPI  R30,LOW(0x1)
	BRNE _0xAF
	CPI  R19,37
	BRNE _0xB0
	RCALL SUBOPT_0xC
	LDI  R16,LOW(0)
	RJMP _0xAB
_0xB0:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0xB1
	LDI  R17,LOW(1)
	RJMP _0xAB
_0xB1:
	CPI  R19,43
	BRNE _0xB2
	LDI  R21,LOW(43)
	RJMP _0xAB
_0xB2:
	CPI  R19,32
	BRNE _0xB3
	LDI  R21,LOW(32)
	RJMP _0xAB
_0xB3:
	RJMP _0xB4
_0xAF:
	CPI  R30,LOW(0x2)
	BRNE _0xB5
_0xB4:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0xB6
	ORI  R17,LOW(128)
	RJMP _0xAB
_0xB6:
	RJMP _0xB7
_0xB5:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0xAB
_0xB7:
	CPI  R19,48
	BRLO _0xBA
	CPI  R19,58
	BRLO _0xBB
_0xBA:
	RJMP _0xB9
_0xBB:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0xAB
_0xB9:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0xBF
	RCALL SUBOPT_0xD
	LD   R30,X
	RCALL SUBOPT_0xE
	RJMP _0xC0
_0xBF:
	CPI  R30,LOW(0x73)
	BRNE _0xC2
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xF
	RCALL _strlen
	MOV  R16,R30
	RJMP _0xC3
_0xC2:
	CPI  R30,LOW(0x70)
	BRNE _0xC5
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xF
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0xC3:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0xC6
_0xC5:
	CPI  R30,LOW(0x64)
	BREQ _0xC9
	CPI  R30,LOW(0x69)
	BRNE _0xCA
_0xC9:
	ORI  R17,LOW(4)
	RJMP _0xCB
_0xCA:
	CPI  R30,LOW(0x75)
	BRNE _0xCC
_0xCB:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0xCD
_0xCC:
	CPI  R30,LOW(0x58)
	BRNE _0xCF
	ORI  R17,LOW(8)
	RJMP _0xD0
_0xCF:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0xFE
_0xD0:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0xCD:
	SBRS R17,2
	RJMP _0xD2
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0xD3
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0xD3:
	CPI  R21,0
	BREQ _0xD4
	SUBI R16,-LOW(1)
	RJMP _0xD5
_0xD4:
	ANDI R17,LOW(251)
_0xD5:
	RJMP _0xD6
_0xD2:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
_0xD6:
_0xC6:
	SBRC R17,0
	RJMP _0xD7
_0xD8:
	CP   R16,R20
	BRSH _0xDA
	SBRS R17,7
	RJMP _0xDB
	SBRS R17,2
	RJMP _0xDC
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0xDD
_0xDC:
	LDI  R19,LOW(48)
_0xDD:
	RJMP _0xDE
_0xDB:
	LDI  R19,LOW(32)
_0xDE:
	RCALL SUBOPT_0xC
	SUBI R20,LOW(1)
	RJMP _0xD8
_0xDA:
_0xD7:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0xDF
_0xE0:
	CPI  R18,0
	BREQ _0xE2
	SBRS R17,3
	RJMP _0xE3
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x127
_0xE3:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x127:
	ST   -Y,R30
	RCALL SUBOPT_0x11
	CPI  R20,0
	BREQ _0xE5
	SUBI R20,LOW(1)
_0xE5:
	SUBI R18,LOW(1)
	RJMP _0xE0
_0xE2:
	RJMP _0xE6
_0xDF:
_0xE8:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0xEA
	SBRS R17,3
	RJMP _0xEB
	SUBI R19,-LOW(7)
	RJMP _0xEC
_0xEB:
	SUBI R19,-LOW(39)
_0xEC:
_0xEA:
	SBRC R17,4
	RJMP _0xEE
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0xF0
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0xEF
_0xF0:
	ORI  R17,LOW(16)
	RJMP _0xF2
_0xEF:
	CP   R20,R18
	BRLO _0xF4
	SBRS R17,0
	RJMP _0xF5
_0xF4:
	RJMP _0xF3
_0xF5:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0xF6
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0xF2:
	SBRS R17,2
	RJMP _0xF7
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x11
	CPI  R20,0
	BREQ _0xF8
	SUBI R20,LOW(1)
_0xF8:
_0xF7:
_0xF6:
_0xEE:
	RCALL SUBOPT_0xC
	CPI  R20,0
	BREQ _0xF9
	SUBI R20,LOW(1)
_0xF9:
_0xF3:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0xE9
	RJMP _0xE8
_0xE9:
_0xE6:
	SBRS R17,0
	RJMP _0xFA
_0xFB:
	CPI  R20,0
	BREQ _0xFD
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0xE
	RJMP _0xFB
_0xFD:
_0xFA:
_0xFE:
_0xC0:
	LDI  R16,LOW(0)
_0xAB:
	RJMP _0xA6
_0xA8:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x12
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x12
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G2
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	RJMP _0x125
_Affiche_LCD:
	RCALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x14
	RCALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x13
	RJMP _0x125
_ds1621_get_status:
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
	RCALL _i2c_start
	SUBI R16,-LOW(1)
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x0
	RCALL _i2c_read
	MOV  R17,R30
	RCALL _i2c_stop
	MOV  R30,R17
	RCALL __LOADLOCR2
	RJMP _0x126
_ds1621_set_status:
	RCALL _i2c_start
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x1B
	RCALL _i2c_stop
	ADIW R28,2
	RET
_ds1621_set_temp:
	RCALL _i2c_start
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x1C
	LDD  R30,Y+1
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x0
	RCALL _i2c_write
	RCALL _i2c_stop
_0x112:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _ds1621_get_status
	ANDI R30,LOW(0x10)
	BRNE _0x112
_0x126:
	ADIW R28,3
	RET
_ds1621_start:
	RCALL _i2c_start
	LD   R30,Y
	LSL  R30
	RCALL SUBOPT_0x1A
	LDI  R30,LOW(238)
	RCALL SUBOPT_0x1C
	RCALL _i2c_stop
	ADIW R28,1
	RET
_ds1621_init:
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x19
	SUBI R30,-LOW(8)
	ST   -Y,R30
	RCALL _ds1621_set_status
	RCALL SUBOPT_0x1D
	LDI  R30,LOW(162)
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL SUBOPT_0x1E
	LDI  R30,LOW(161)
	ST   -Y,R30
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1E
	RCALL _ds1621_start
_0x125:
	ADIW R28,4
	RET
_ds1621_temperature_10:
	SBIW R28,2
	ST   -Y,R16
	LDD  R30,Y+3
	LSL  R30
	ORI  R30,LOW(0x90)
	RCALL SUBOPT_0x16
	LDI  R30,LOW(170)
	RCALL SUBOPT_0x1C
	RCALL _i2c_start
	SUBI R16,-LOW(1)
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x14
	RCALL _i2c_read
	STD  Y+2,R30
	RCALL SUBOPT_0x0
	RCALL _i2c_read
	STD  Y+1,R30
	RCALL _i2c_stop
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R30,LOW(7)
	RCALL __ASRW12
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	RCALL __MULW12
	LDD  R16,Y+0
	ADIW R28,4
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G7:
	.BYTE 0x4

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G7:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G7)
	SBCI R31,HIGH(-__base_y_G7)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x1F
	LDD  R4,Y+1
	LDD  R5,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x1F
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x1F
	RCALL __lcd_ready
	RCALL SUBOPT_0x14
	RCALL __lcd_write_data
	CLR  R30
	MOV  R5,R30
	MOV  R4,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R4
	CP   R6,R4
	BRSH _0x11E
	__lcd_putchar1:
	INC  R5
	RCALL SUBOPT_0x0
	ST   -Y,R5
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x11E:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G7:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G7:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R6,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G7,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G7,3
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x20
	RCALL __long_delay_G7
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G7
	RCALL __long_delay_G7
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x1F
	RCALL __long_delay_G7
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x1F
	RCALL __long_delay_G7
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x1F
	RCALL __long_delay_G7
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G7
	CPI  R30,LOW(0x5)
	BREQ _0x123
	CLR  R30
	RJMP _0x124
_0x123:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x1F
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x124:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x0:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	RCALL _ds1621_temperature_10
	__PUTW1R 18,19
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2:
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	RCALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x4:
	__GETW2R 18,19
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x5:
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	RCALL __MODW21U
	ST   -Y,R31
	ST   -Y,R30
	RJMP _abs

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	__GETD1N 0xDF
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	RCALL _sprintf
	ADIW R28,16
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Affiche_LCD

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xA:
	ST   -Y,R30
	RJMP _putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xC:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0xD:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x14:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x15:
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0x90)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	MOV  R16,R30
	RCALL _i2c_start
	ST   -Y,R16
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	LDI  R30,LOW(172)
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	ST   -Y,R16
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	LDD  R30,Y+1
	LSL  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	ORI  R30,LOW(0x90)
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	LD   R30,Y
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x1C:
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x1D:
	LDD  R30,Y+3
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1E:
	RCALL _ds1621_set_temp
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x1F:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x20:
	RCALL __long_delay_G7
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G7

_abs:
	ld   r30,y+
	ld   r31,y+
	sbiw r30,0
	brpl __abs0
	com  r30
	com  r31
	adiw r30,1
__abs0:
	ret

	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_puts:
	ld   r30,y+
	ld   r31,y+
__puts0:
	ld   r22,z+
	tst  r22
	breq __puts1
	push r30
	push r31
	rcall __puts2
	pop  r31
	pop  r30
	rjmp __puts0
__puts1:
	ldi  r22,10
__puts2:
	st   -y,r22
	rjmp _putchar

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

