/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : TP3 liaison RS232
Version : 2
Date    : 24/01/2010
Author  : Philippe Mariano                         
Company : Lyce Pierre Emile Martin                             
Comments: Fichier lve
Transmission de la temprature ambiante sur la liaison srie

Fichier: TempRS232.c

Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <mega8535.h>
// -------------------------------------------------------------------------------------------------------
// Bibliothques  non gnres par Wizard ( rajouter manuellement)
// -------------------------------------------------------------------------------------------------------      
#include <delay.h>    // contient la fonction delay_ms
#include <stdio.h>    // contient la fonction sprintf 
#include <stdlib.h>   // contient la fonction itoa
#include <math.h>     // contient la fonction abs
#include <ssi.h>      // contient la fonction Affiche_LCD
// -------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------
// I2C Bus functions
#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
#endasm
#include <i2c.h>
// -------------------------------------------------------------------------------------------------------
// DS1621 Thermometer/Thermostat functions
#include <ds1621.h>
// -------------------------------------------------------------------------------------------------------
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>
// -------------------------------------------------------------------------------------------------------

// -------------------------------------------------------------------------------------------------------
// Programme principal
// -------------------------------------------------------------------------------------------------------
void main(void)
{
// Declare your local variables here   
// -------------------------------------------------------------------------------------------------------
//type 	   		nom 				   				dsignation  
// -------------------------------------------------------------------------------------------------------
char display_buffer_ligne0[17]; 					// tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 	       			// tampon ligne 1 de l'afficheur
unsigned int  temp_n_1, temp_n;						// Temprature  l'instant n et  l'instant n-1
unsigned int Aff_Temp_Entier, Aff_Temp_decimal ; 	// Partie entire et partie dcimale de la temprature  
// -------------------------------------------------------------------------------------------------------
// Input/Output Ports initialization
// Port A initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In
// State0=P State1=T State2=T State3=T State4=T State5=T State6=T State7=T
PORTA=0x01;
DDRA=0x00;
// -------------------------------------------------------------------------------------------------------
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: Off
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 9600
UCSRA=0x00;
UCSRB=0x08;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x33;
// -------------------------------------------------------------------------------------------------------
// I2C Bus initialization
i2c_init();
// -------------------------------------------------------------------------------------------------------
// DS1621 Thermometer/Thermostat initialization
// tlow: 24C
// thigh: 55C
// Tout polarity: 0
ds1621_init(0,24,55,0);
// -------------------------------------------------------------------------------------------------------
// LCD module initialization
lcd_init(16);   

// -----------------------------------------------------------------------------------------------------------
// --------------------------------------------- Message d'accueil -------------------------------------------
// -----------------------------------------------------------------------------------------------------------
temp_n = ds1621_temperature_10(0);  
sprintf(display_buffer_ligne0,"Capteur DS1621  ");
sprintf(display_buffer_ligne1,"Temp. = %-i.%-u%-cC",temp_n/10,abs(temp_n%10),0xdf);
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 

while (1)
      { 
// -----------------------------------------------------------------------------------------------------------
// --------------------------------------- Champs lecture des donnes ----------------------------------------
// -----------------------------------------------------------------------------------------------------------
// Lecture de la temprature mesure par le DS1621 toutes les secondes 
// -----------------------------------------------------------------------------------------------------------
	temp_n = ds1621_temperature_10(0);    
	
// -----------------------------------------------------------------------------------------------------------
// ------------------------------------------------ Champs Traitement ----------------------------------------
// -----------------------------------------------------------------------------------------------------------      
Aff_Temp_Entier =  temp_n/10;
Aff_Temp_decimal = abs(temp_n%10);    
 
// -----------------------------------------------------------------------------------------------------------
// --------------------------------------- Champs criture des rsultats -------------------------------------
// -----------------------------------------------------------------------------------------------------------
// Affichage de la temprature sur le LCD et transfert vers le PC  
	if (!PINA.0)
	  { putchar(0x06); delay_ms(100);}
	else if (temp_n_1 != temp_n)
 	  {  
  		sprintf(display_buffer_ligne0,"Capteur DS1621  ");
    	sprintf(display_buffer_ligne1,"Temp. = %-i.%-u%-cC",Aff_Temp_Entier, Aff_Temp_decimal,0xdf);
     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
        puts(display_buffer_ligne1);  
        putchar(0x0D); // retour  la ligne
        temp_n_1 = temp_n;	  
      }    
  };   // fin while(1)
} // fin main
